/*-------------------------------------------------------------------*/
/* filename -   mapcolor.cpp                                         */
/*                                                                   */
/* function(s)                                                       */
/*          mapColor -- maps a color into a pointer into the current */
/*                      palette.                                     */
/*-------------------------------------------------------------------*/

/*-------------------------------------------------------------------*/
/*                                                                   */
/*    Turbo Vision -  Version 1.0                                    */
/*                                                                   */
/*                                                                   */
/*    Copyright (c) 1991 by Borland International                    */
/*    All Rights Reserved.                                           */
/*                                                                   */
/*-------------------------------------------------------------------*/

/*-------------------------------------------------------------------*/
/*  JDP MODIFIED 07/09/92                                            */
/*  ---------------------                                            */
/*  PURPOSE: To allow the use of black on black color (attr. 0)      */
/*                                                                   */
/*  IMPLEMENTATION:                                                  */
/*  - In this source file, return 0 if color index is 0.             */
/*  - In source file MYDRIVER.CPP, remove special case when attr==0  */
/*  - In source file MYCOLOR.CPP, remove logic which displays        */
/*     errorAttr if color==0                                         */
/*-------------------------------------------------------------------*/
#pragma hdrstop                        //** JDP
#define Uses_TView
#define Uses_TGroup
#include <tv.h>

uchar TView::mapColor( uchar color )
{
    if( color == 0 )                   //** JDP
      return 0;
    TView *cur = this;
    do  {
        TPalette& p = cur->getPalette();
        if( p[0] != 0 )
        {
          if( color > p[0] )
            return errorAttr;
          color = p[color];
          if( color == 0 )             //** JDP
            return 0;
        }
        cur = cur->owner;
    } while( cur != 0 );
    return color;
}
